// Copyright (c) The University of Edinburgh,  2008.
package org.biosphere.portlets;

import java.util.HashMap;
import java.util.Map;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.servlet.ServletException;
import javax.portlet.RenderRequest;
import javax.portlet.PortletRequest.*;

import org.biosphere.portlets.util.Data;
import org.biosphere.portlets.util.DatabaseTreeModelAdaptor;
import org.biosphere.portlets.util.TreeModelJavaScriptAdaptor;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.validation.BindException;
import org.springframework.validation.Errors;
import org.springframework.web.portlet.ModelAndView;
import org.springframework.web.portlet.mvc.SimpleFormController;

import javax.portlet.RenderResponse;


public class Controller extends SimpleFormController  {
	private Data data = null;
	
    
    public ModelAndView onSubmitRender(RenderRequest request, RenderResponse response, Object command, BindException errors) {
	//onSubmitRender(Object command,	BindException errors) throws Exception {
		System.out.println("\nController: ****************** onSubmitRender() **************************");
		Data data = (Data) command;
		if(data==null) {
		    data = new Data();	
		    System.out.println("Controller: error cought data=null");	    
		}
		String name = ((Data) command).getName();
		if(name==null) {
		    data = new Data();
		    name = data.getName();
		    System.out.println("\nController: error cought data.name=null");}
		System.out.println("\nController: returning from DataForm view to DataForm");
		setJSPHeader(response); //add ccs and dojo JS
		// build TreeModel of database collections
		String rept = DatabaseTreeModelAdaptor.buildCollectionModel(data);
		if(rept.length()>0) rept = "\n<h> Errors were encountered:<p>"+rept;
		// generate dojo js tree
		String newData = TreeModelJavaScriptAdaptor.generateDojoTree(data);
		System.out.println("\nController: newData="+newData);
		ModelAndView mav = new ModelAndView("data");
		mav.addObject("data", new Data());
		mav.addObject("newData", newData+rept);
		return mav;
	
	}
	

	
	public void setData(Data data){
	    System.out.println("++++++++++set data++++++++++++");
	    System.out.println("data="+data.toString());
	    this.data = data;
	}

	public Data getData(){
	    System.out.println("++++++++++get data++++++++++++");
	    System.out.println("data="+this.data.toString());
	    return this.data;
	}


    public void setJSPHeader(RenderResponse renderResponse) {
	String contextPath = "/gridsphere/javascript";
        renderResponse.setProperty("CSS_HREF", contextPath + "/dojo/dijit/themes/tundra/tundra.css");
        renderResponse.addProperty("JAVASCRIPT_SRC", contextPath + "/dojo/dojo/dojo.js\" djConfig=\"parseOnLoad: true");
    }

  
}
