// Copyright (c) The University of Edinburgh,  2008.
package org.biosphere.portlets.util;

import uk.org.ogsadai.client.toolkit.DataIterator;
import uk.org.ogsadai.client.toolkit.activities.xmldb.XMLListCollections;
import uk.org.ogsadai.client.toolkit.activities.xmldb.XMLListResources;
import javax.swing.tree.*;


public class DatabaseTreeModelAdaptor {

    public static boolean DEBUG = false;

    public static String buildCollectionModel(Data data) {
	DefaultMutableTreeNode root = (DefaultMutableTreeNode)data.getRoot();
	String coll = data.getName();
	return buildCollectionModel(root,coll);
    }
    
    public static String buildCollectionModel(DefaultMutableTreeNode parent, String collection) {
	String result = "";
	// get all collections and recurse down tree of collections adding collections to TreeModel
    	XMLDBCollectionListingUtil cclient = new XMLDBCollectionListingUtil();
	try {
	    if(cclient.execute("http://localhost:8080/dai/services",collection)) {
		XMLListCollections list	= cclient.getResults();
		while (list.hasNextData()) {
		    DataIterator iterator = list.nextData();
		    while (iterator.hasNext())
			{
			    String subcollection = (String)iterator.next(); 
			    String path = subcollection;
			    if(collection!=null)
				path = collection+"/"+subcollection;
			    if(DEBUG) result+=path+"<p>";
			    DefaultMutableTreeNode node = TreeUtils.getOrCreateChildNode(parent,subcollection);
			    result += buildCollectionModel(node,path);
			}
		}
		// add resources to TreeModel as well
		XMLDBResourceListingUtil rclient = new XMLDBResourceListingUtil();
		try {
		    if(rclient.execute("http://localhost:8080/dai/services",collection)) {
			XMLListResources rlist = rclient.getResults();
			while (rlist.hasNextData())
			    {
				DataIterator iterator = rlist.nextData();
				while (iterator.hasNext())
				    {
					String resource = (String)iterator.next();
					TreeUtils.getOrCreateChildNode(parent,resource);
					if(DEBUG) 
					    if(collection!=null) result+=collection+"/"+resource+"<p>";
					    else result+=resource+"<p>";
				    }
			    } 
		    }
		    else {  // fail to complete resource query
			return "Configuration:\n"+rclient.getConfig()+"\nConnection report:\n"+rclient.getReport();
		    }
		}
		catch(Exception e) { // exception from resource query
		    e.printStackTrace();
		    return "Configuration:\n"+rclient.getConfig()+"\nConnection report:\n"+rclient.getReport()+"\n"+e.toString();
		}
	    }
	    else { // fail to complete collection query
		return "Configuration:\n"+cclient.getConfig()+"\nConnection report:\n"+cclient.getReport();
	    }	
	}
	catch(Exception e) { // exception from collection query
	    e.printStackTrace();
	    return "Configuration:\n"+cclient.getConfig()+"\nConnection report:\n"+cclient.getReport()+"\n"+e.toString();
	}
	return result;
    }


}