// Copyright (c) The University of Edinburgh,  2008.
package org.biosphere.portlets.util;

import java.util.Enumeration;
import javax.swing.tree.*;


/**
 * generate JavaScript (text) from TreeModel
 *  @author stuart@aiai.ed.ac.uk  
 */

public class TreeModelJavaScriptAdaptor {

    private static String store = "hierarchy";
    private static String toplabel = "eXist DB";

    public static String generateDojoTree(Data data) {
	StringBuffer result = new StringBuffer();
	appendRequire(result);
	appendTreeHeader(result);
	//appendTestData(result);
	appendTreeData(result,(DefaultMutableTreeNode)data.getRoot());
	appendTreeFooter(result);
	return result.toString();
    }


    // dojo require statements
    public static void appendRequire(StringBuffer b) {
	b.append("<script>\ndojo.require(\"dojo.data.ItemFileWriteStore\");\ndojo.require(\"dijit.Tree\");\ndojo.require(\"dojo.parser\");\ndojo.require(\"dojo.dnd.Source\");\ndojo.require(\"dijit._tree.dndSource\");\n</script>");
    }
    
    // header for tree data
    public static void appendTreeHeader(StringBuffer b) {
	b.append("\n<script type=\"text/javascript\" charset=\"utf-8\">\nvar data = {data: { label: \"name\",\n identifier: \"name\",\n items: [\n");
    }

    // tree data
    public static void appendTreeData(StringBuffer b, DefaultMutableTreeNode node) {
	if(node.isLeaf()) {
	    b.append("\n{ name:\'"+node.getUserObject().toString()+"\', type:\'category\'}");
	}
	else {
	    b.append("\n{ name:\'"+node.getUserObject().toString()+"\', type:\'category\',\n children: [");
	    Enumeration e = node.children();
	    boolean isFirst = true;
	    while(e.hasMoreElements()) {
		if(!isFirst) 
		    b.append(","); 
		isFirst=false;
		appendTreeData(b,(DefaultMutableTreeNode)e.nextElement());
	    }
	    b.append("]}");
	}
    }

    public static void appendTestData(StringBuffer b){
	b.append("{name:\'Thing\', type:\'category\',\n  children: [\n     { name:\'Event\', type:\'category\' },\n     { name:\'Object\', type: \'category\',\n       children: [\n          { name:\'Organ\', type:\'category\' }, \n          { name:\'Cell\', type:\'category\' }, \n          { name:\'Fluid\', type:\'category\' }\n       ]\n     },\n     { name:\'Abstract\', type: \'category\'}\n  ]\n  }");
    }
 
    // footer for data store and <div tree def > line
    public static void appendTreeFooter(StringBuffer b) {
	b.append("]}};\nvar "+store+"=new dojo.data.ItemFileReadStore(data);\n</script>\n<div class=tundra dojoType=\"dijit.Tree\" id=\"mytree\" store=\""+store+"\"></div>");
    }
    
    
}





