// Copyright (c) The University of Edinburgh,  2008.
package org.biosphere.portlets.util;

import java.util.Enumeration;
import javax.swing.tree.*;

/**
 * Tree Utilities
 *  @author stuart@aiai.ed.ac.uk  
 */

public class TreeUtils {

    // return a child node with the specified name, creating it if necessary
    public static DefaultMutableTreeNode getOrCreateChildNode(DefaultMutableTreeNode parent, Object child) {
	// check for a child
	DefaultMutableTreeNode node = getChild(parent,child.toString());
	if(node==null) { // if none, create new TreeNode and add it as child to parent
	    node = new DefaultMutableTreeNode(child);
	    parent.add(node);
	}
	return node;
    }

    // return the child node with the specified name, or return null
    public static DefaultMutableTreeNode getChild(DefaultMutableTreeNode parent, String name) {
	if(!parent.isLeaf()) {
	    Enumeration e = parent.children();
	    while(e.hasMoreElements()) {
		DefaultMutableTreeNode n = (DefaultMutableTreeNode)e.nextElement();
		if((n.getUserObject()).toString().equals(name))
		    return n;
	    }
	}
	return null;
    }
}